<template>
  <section class="card-list-container">
    <list-animation>
      <Card appear="true" v-for="item in item_list" :key="item" :card="item" />
    </list-animation>
    <infinite-loading :on-infinite="loadMore" ref="infiniteLoading" :allLoaded="is_complete"></infinite-loading>
  </section>
</template>

<script>
import Card from '~components/card/_Card.vue'
import infiniteLoading from '~components/infiniteLoading.vue'
import listAnimation from '~components/listAnimation.vue'
import { mapMutations } from 'vuex'

export default {
  fetch ({ store }) {
    console.log('async fetch init son-dk load')
    return store.dispatch('list_view/LOADMORE_LISTVIEW_DATA', store.state.list_view.list.length)
  },
  computed: {
    item_list () {
      return this.$store.state.list_view.list
    },
    is_complete () {
      let itemListTotal = Number(this.$store.state.list_view.api_headers['x-total-count'])
      if (itemListTotal > this.item_list.length || itemListTotal !== 0 && this.item_list.length === 0) {
        return false
      } else {
        return true
      }
    },
    topBarSettings () {
      return { // copy me to every page with setTopbarSettings actions
        pageTitle: 'SON DAKİKA',
        topbarMenu: {
          isBackIconVisible: false,
          isCardToggleIconVisible: false,
          isFilterIconVisible: false,
          isSearchIconVisible: true,
          isSettingsIconVisible: false,
          isAddFavoritesIconVisible: false
        }
      }
    }
  },
  methods: {
    loadMore () {
      return this.$store.dispatch('list_view/LOADMORE_LISTVIEW_DATA', this.$store.state.list_view.list.length)
    },
    setTopbarSettings () {
      this.$store.commit('pushTopBarLayout', this.topBarSettings.topbarMenu)
      this.$store.dispatch('SET_PAGE_TITLE', this.topBarSettings.pageTitle)
    },
    ...mapMutations({
      closeSidebar: 'closeSidebar'
    })
  },
  created () {
    this.closeSidebar()
  },
  beforeMount () {
    this.setTopbarSettings()
  },
  mounted () {
    // this.loadInit()
  },
  components: {
    Card,
    infiniteLoading,
    listAnimation
  }
}

</script>

